//#################################################################
// fontsoft.c
//
// Text mit Software Fonts schreiben
//
// Special Version fr APEs FontCreator
//
// Routine wurde optimiert fr den Fall das ypos der Buchstaben auf den Adressen
// 0,8,16,24,32,40,48,56 beginnt. Dann kann man statt nur einzelne
// Pixel zu setzen gleich ein ganzes Byte mit 8 Pixeln schreiben.
// Buchstaben werden bei diesen Positionen mehr als 8 mal schneller angezeigt !
// Mit ypos ist das obere Ende des Buchstabens gemeint.
//
// Bei den FIXED Fonts ist noch keine Optimierung eingebaut. 
//
// Todo: Eventuell pgm_read_byte_far() nehmen ?
//
// hk@holger-klabunde.de
// http://www.holger-klabunde.de
//#################################################################
// 14.12.2007
//#################################################################
// Compiler AVR-GCC 4.1.2
//#################################################################
#include <avr/pgmspace.h>

#include "ks108.h"
#include "draw.h"
#include "fontsoft.h"

#include "font5x7.h"
#include "font6x8.h"
#include "font12x16.h"
#include "arial24bold.h"
#include "impact32.h"
#include "comic32.h"
#include "corsiva_12.h"
#include "arial_bold_14.h"

unsigned char fontwidth,fontheight,fonttype;   //Breite,Hhe in Pixeln
unsigned const char *font;
unsigned char xtextcursor,ytextcursor;


//########################################################################
// Hier trgt man die FontArrays ein
void SetFont(unsigned char num)
//########################################################################
{
 fontwidth=1; fontheight=1; fonttype=PROP_FONT; // Defaults

 switch(num)
  {
   case FIX_FONT5X7:   fontwidth=5; fontheight=7; font=Font5x7; fonttype=FIXED_FONT; break;
   case FIX_FONT6X8:   fontwidth=6; fontheight=8; font=Font6x8; fonttype=FIXED_FONT; break;
   case FIX_FONT12X16: fontwidth=12; fontheight=16; font=Font12x16; fonttype=FIXED_FONT; break;
   case ARIAL_14_BOLD: font=Arial_Bold_14; break;
   case ARIAL_24_BOLD: font=arial24bold; break;
   case COMIC_32:      font=comic32; break;
   case CORSIVA_12:    font=Corsiva_12; break;
   case IMPACT_32:     font=impact32; break;
   default: fontwidth=0; fontheight=0; fonttype=0; break; // Unknown Font
  }
}

//########################################################################
//Schreibt ein einzelnes Zeichen an Position x,y
//Fr proportional Fonts mit variabler Breite aus APEs Fontgenerator.
void LCDSoftCharProp(char ch, unsigned char xpos, unsigned char ypos)
//########################################################################
{
 unsigned int fontoffset,fontstart;
 unsigned char i,j,k,by,mask,tmpmask,pixels, fontvbytes;
 unsigned char xp,yp;
 
 fontheight = pgm_read_byte(&font[3]);

//Htte APE doch blo ein SPACE in die Tabelle mit reingelegt ;)
//Bei FontCreator2.1 ist ein SPACE mit drin !
// if(ch==' ') { fontwidth = pgm_read_byte(&font[2]); return; }

 if(ch < pgm_read_byte(&font[4]) ) return; // Zeichennummer zu klein
 if(ch > ( pgm_read_byte(&font[4]) + pgm_read_byte(&font[5]) ) ) return; // Zeichennummer zu gro
 
 fontwidth = pgm_read_byte(&font[PROP_FONT_HEADER_SIZE + ch - ' ']); 

 fontstart = PROP_FONT_HEADER_SIZE + (unsigned int)pgm_read_byte(&font[5]); // Beginn der Fontdaten

 // addiere alle Zeichenbreiten bis zum aktuellen Zeichen
 fontoffset = 0;
 for(i=0; i<(ch - ' '); i++) fontoffset += pgm_read_byte(&font[PROP_FONT_HEADER_SIZE + i]);

 //Zeichenhhe in Bytes
 fontvbytes = (fontheight+7)/8;

 fontoffset *= fontvbytes; // alle davorliegenden Zeichen berspringen
 fontoffset += fontstart;  // Nun haben wir die Startaddresse des Zeichens

 yp=ypos;
 for(k=0; k<fontvbytes; k++)
  {
   pixels=8; // erstmal

   if(k == fontvbytes-1) // Im unteren Zeichenteil evtl. nur Restpixel zeichnen 
    {
     by = fontheight % 8;
     if(by!=0) pixels = by;
    }

   tmpmask=0x01;               //Bei D0 anfangen
   if(pixels!=8) tmpmask <<= (8 - pixels); // Restpixel sind verschoben !

   xp=xpos;
   for(i=0; i<fontwidth; i++) //ber die Breite des Zeichens
    {
     by=pgm_read_byte(&font[fontoffset++]); //Ein Byte des Zeichens holen

     if( (yp % 8) !=0 || pixels != 8)
      {
       mask=tmpmask;

       for(j=0; j<pixels; j++)
        {
         SetPixel(xp , yp + j,(by&mask));
         mask<<=1; //Nchstes Bit
        }//for j

      }
     else
      {
           if(SetPosition(xp,yp)) //Chip und Adresse einstellen
            {
             WriteDisplay(by);   //8 Pixel schreiben
            } 
      }

     xp++;
    }//for i

   if( (yp % 8) !=0 || pixels != 8)
    {
     for(j=0; j<pixels; j++) // virtual spacing Spalte, 1 Leerpixel zeichnen
      {
       SetPixel(xp , yp + j, 0);
      }//for j
    }
   else
    {
           if(SetPosition(xp,yp)) //Chip und Adresse einstellen
            {
             WriteDisplay(0);   //8 Pixel schreiben
            } 
    }   

   yp +=8 ;
  }//for k

 fontwidth++; // virtual spacing Spalte, 1 Leerpixel addieren
}

//########################################################################
//Schreibt ein einzelnes Zeichen an Position x,y
//Fr APE fixed Fonts mit fester Breite.
void LCDSoftCharFix(char ch, unsigned char xpos, unsigned char ypos)
//########################################################################
{
unsigned char by,mask;
unsigned char i,j,k,fontvbytes;
unsigned int fontoffset;
 
 ch-=' '; // APE font

 fontvbytes = (fontheight+7)/8;
 fontoffset = (unsigned int)ch * fontvbytes * fontwidth;
  
 for(i=0; i<fontwidth; i++) //ber die Breite des Zeichens
  {
   for(k=0; k<fontvbytes; k++)
    {
     by=pgm_read_byte(&font[fontoffset++]); //Ein Byte des Zeichens holen
     mask=0x01;               //Bei D0 anfangen

     for(j=0; j<8; j++)
      {
       SetPixel(xpos+i,ypos + j + k*8 ,(by&mask));
       mask<<=1;
      }//for j
    }//for k

  }//for i
}

//########################################################################
//Schreibt einen Text an Position x,y
//Mit automatischem Zeilenvorschub falls der Text zu lang war.
//Noch keine Steuerzeichen wie TAB,CR,LF integriert
void LCDText(char *putstr, unsigned char xpos, unsigned char ypos)
//########################################################################
{
 char ps;

 xtextcursor=xpos; ytextcursor=ypos;

 while((ps = *putstr))
  {
   putstr++;
   if (ps== 0) break;
   LCDChar(ps,xtextcursor,ytextcursor);
  }
}

//########################################################################
//Schreibt ein Zeichen an Position x,y
//Mit automatischem Zeilenvorschub falls der Text zu lang war.
//Noch keine Steuerzeichen wie TAB,CR,LF integriert
void LCDChar(char ch, unsigned char xpos, unsigned char ypos)
//########################################################################
{

 if(fonttype==0) return; //Kein Font ausgewhlt

 xtextcursor=xpos; ytextcursor=ypos;
 
 if(fonttype==FIXED_FONT) LCDSoftCharFix(ch,xtextcursor,ytextcursor);
 if(fonttype==PROP_FONT) LCDSoftCharProp(ch,xtextcursor,ytextcursor);
 xtextcursor+=fontwidth; //Nchstes Zeichen
 if(xtextcursor>=LCD_WIDTH) { xtextcursor=0; ytextcursor+=fontheight; } //Nchste Zeile
}

//##########################################################
void SetTextCursor(unsigned char x, unsigned char y)
//##########################################################
{
 xtextcursor=x; ytextcursor=y;
}

/*
//########################################################################
//Zeigt eine bersicht der im Font enthaltenen Zeichen
void ShowSoftFont(unsigned char num)
//########################################################################
{
 unsigned char i,xp,yp;
 
 ClearScreen();

 xp=0; yp=0;
 SetFont(num);
 
 for(i=0x20; i<128; i++)
  {
   LCDSoftChar(i,xp,yp);
   xp+=fontwidth; //Nchstes Zeichen
   if(xp>=LCD_WIDTH) { xp=0; yp+=fontheight; } //Nchste Zeile
  }
}
*/
