//************************************************************************
// Datei: display.c
// Hauptprogramm
//
// Demoprogramm um Text und Grafik auf
// KS108 Grafik-LCD-Display anzuzeigen
// Display: Displaytech 64240A 240x64 Pixel
//
// Erluterungen zu den Funktionen stehen in den entsprechenden
// *.c Dateien.
//
// hk@holger-klabunde.de
// http://www.holger-klabunde.de
//************************************************************************
// 17.11.2006
//************************************************************************
// Compiler WinAVR 3.4.5
//************************************************************************

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <string.h>
//Note: 1. F_CPU im makefile definieren, 2. Optimization ein
#include <util/delay.h>

#include "protos.h"
#include "ks108.h"
#include "paul.h"
#include "mydefs.h"
#include "bitmap.h"
#include "draw.h"
#include "fontsoft.h"
#include "printf.h"

int main(void)
{
// int i;
 
// ser_init(); //Serielle Schnittstelle einstellen

 sei();              //enable interrupts

 DisplayOn();

//Beginn Endlosschleife
 while(1)
  {
 ClearScreen();                     
 LoadBitmap_P(paulbmp, 0 , 0, paulWIDTH, paulHEIGHT);  //Bitmap laden
 LoadBitmap_P(paulbmp, 65 , 2, paulWIDTH, paulHEIGHT); //Noch eine Bitmap laden und abschneiden
 Delay1ms(3000);

 ClearScreen();                     
 SetFont(FIX_FONT5X7);
 LCDText("Fix 5x7",0,0);
 SetFont(FIX_FONT6X8);
 LCDText("Fix 6x8",0,8);
 SetFont(FIX_FONT12X16);
 LCDText("Fix 12x16",0,20);
 LCDText("123456789",0,38);
 Delay1ms(3000);

 ClearScreen();                     
 SetFont(ARIAL_24_BOLD);
 LCDText("Arial24",0,0);
 LCDText("123456789",0,32);
 Delay1ms(3000);

 ClearScreen();                     
 SetFont(IMPACT_32);
 LCDText("Impact32",0,0);
 LCDText("123456789",0,32);
 Delay1ms(3000);

 ClearScreen();                     
 SetFont(COMIC_32);
 SetTextCursor(0,0);
 printf("Comic32"); // geht auch mit printf() statt LCDText()
 SetTextCursor(0,32);
 printf("123456789");
 Delay1ms(3000);

 ClearScreen();                     
 SetFont(CORSIVA_12);
 LCDText("Corsiva12",0,0);
 Delay1ms(3000);

 ClearScreen();                     
 SetFont(ARIAL_14_BOLD);
 LCDText("ArialBold14",0,0);
 Delay1ms(3000);

  } //Endlosschleife
}

//###################################################################################
//Nicht sonderlich genau !!
void Delay1ms(unsigned int time)
//###################################################################################
{
 unsigned int i;

 for(i=0; i<time; i++) _delay_ms(1);
}
